# Introduction

- [Where To Start](#where-to-start)
- [Laravel Philosophy](#laravel-philosophy)

<a name="where-to-start"></a>
## Where To Start

Learning a new framework can be daunting, but it's also exciting. To smooth your transition, we've attempted to create very clear, concise documentation for Laravel. Here are some recommendations for what to read first:

- [Installation](/docs/4.1/installation) and [Configuration](/docs/4.1/configuration)
- [Routing](/docs/4.1/routing)
- [Requests & Input](/docs/4.1/requests)
- [Views & Responses](/docs/4.1/responses)
- [Controllers](/docs/4.1/controllers)

After reading through these documents, you should have a good grasp on basic request / response handling in Laravel. Next, you may wish to read about [configuring your database](/docs/4.1/database), the [fluent query builder](/docs/4.1/queries), and the [Eloquent ORM](/docs/4.1/eloquent). Or, you may wish to read about [authentication and security](/docs/4.1/security) so you can start signing people into your application.

<a name="laravel-philosophy"></a>
## Laravel Philosophy

Laravel is a web application framework with expressive, elegant syntax. We believe development must be an enjoyable, creative experience to be truly fulfilling. Laravel attempts to take the pain out of development by easing common tasks used in the majority of web projects, such as authentication, routing, sessions, and caching.

Laravel aims to make the development process a pleasing one for the developer without sacrificing application functionality. Happy developers make the best code. To this end, we've attempted to combine the very best of what we have seen in other web frameworks, including frameworks implemented in other languages, such as Ruby on Rails, ASP.NET MVC, and Sinatra.

Laravel is accessible, yet powerful, providing powerful tools needed for large, robust applications. A superb inversion of control container, expressive migration system, and tightly integrated unit testing support give you the tools you need to build any application with which you are tasked.
